#include "lib/QE_R9880U_210.hh"
#include "lib/QE_R1250_03.hh"
#include "lib/AerogelTransmittance.hh"
#include "lib/Cherenkov.hh"
#include "lib/Kuraray_B3_300.hh"
#include "lib/Kuraray_Y11_300.hh"
#include "lib/PhotonEnergy.hh"

void calc2(int mode){
    char name[100];
    const int nEntries = 80;
    
    //
    // Cherenkov photon spectrum
    //
    double transmission[80];
    double Cherenkov[nEntries]={0};
    double Cherenkovdmy[nEntries]={0};
    double lambda2[nEntries]={0};
    TGraph*chgra[6];
    for(int i=0;i<6;i++) chgra[i]=new TGraph();
    TGraph*trgra[6];
    for(int i=0;i<6;i++) trgra[i]=new TGraph();
    for(int i=0;i<nEntries;i++){
        transmission[i]=AerogelTransmitttance(3,photonEnergy[i]);
        lambda2[i]=Cherenkov(photonEnergy[i]);
        Cherenkov[i] = Cherenkov(photonEnergy[i])*transmission[i]/0.138;
        Cherenkovdmy[i] = Cherenkov(photonEnergy[i])*transmission[i];
        for(int j=0;j<6;j++){
            trgra[j]->SetPoint(i,
                    1240./photonEnergy[i],
                    AerogelTransmitttance((j+0.5)*1.05,photonEnergy[i]));
            chgra[j]->SetPoint(i,
                1240./photonEnergy[i],
                Cherenkov(photonEnergy[i])*
                AerogelTransmitttance((j+0.5)*1.05,photonEnergy[i]));
        }
    }
    

    
    
//***************************:
//
// mode 0 : 波長スペクトラ画像出力
//
//***************************
if(mode == 0 ){
    char output[100]="output0.pdf";
    c1=new TCanvas("c1");
    c1->SetFillStyle(0);
    c1->SetFillColorAlpha(0,0);
    sprintf(name,"%s[",output);
    c1->Print(name);
    

    const int n=nEntries;
    double x[n],y1[n],y2[n];
    for(int i=0;i<nEntries;i++){
        x[i]=1240./photonEnergy[i];
        y1[i]=R9880U_210_QE[i];
        y2[i]=R1250_QE[i];
    }
    pmt1=new TGraph(n,x,y1);
    pmt2=new TGraph(n,x,y2);


    c1->SetGridx();
    c1->SetGridy();
    c1->SetLogy();
    pmt1->GetXaxis()->SetLimits(100,1000);
    pmt1->GetHistogram()->SetMaximum(1);
    pmt1->GetHistogram()->SetMinimum(1e-3);
    pmt1->SetMarkerStyle(20);
    pmt1->SetMarkerSize(0.5);
    pmt1->SetMarkerColor(1);
    pmt1->Draw("ap");
    c1->Print(output);
    
    pmt2->GetXaxis()->SetLimits(100,800);
    pmt2->GetHistogram()->SetMaximum(1);
    pmt2->GetHistogram()->SetMinimum(1e-3);
    pmt2->SetMarkerStyle(20);
    pmt2->SetMarkerSize(0.5);
    pmt2->SetMarkerColor(1);
    pmt2->Draw("ap");
    c1->Print(output);

    
    
    for(int i=0;i<nEntries;i++){
        x[i]=1240./photonEnergy[i];
        y1[i]=-absWLSF_Y11[i];
        y2[i]=emissionWLSF_Y11[i];
    }
    Y11abs=new TGraph(n,x,y1);
    Y11emi=new TGraph(n,x,y2);
    c1->SetLogy(0);
    Y11abs->GetXaxis()->SetLimits(350,650);
    Y11abs->GetHistogram()->SetMaximum(1);
    Y11abs->GetHistogram()->SetMinimum(-1);
    Y11abs->SetMarkerStyle(20);
    Y11abs->SetMarkerSize(0.5);
    Y11abs->SetMarkerColor(4);
    Y11abs->Draw("ap");
    Y11emi->SetMarkerStyle(20);
    Y11emi->SetMarkerSize(0.5);
    Y11emi->SetMarkerColor(3);
    Y11emi->Draw("p");
    c1->Print(output);

    
    for(int i=0;i<nEntries;i++){
        x[i]=1240./photonEnergy[i];
        y1[i]=-absWLSF_B3[i];
        y2[i]=emissionWLSF_B3[i];
    }
    B3abs=new TGraph(n,x,y1);
    B3emi=new TGraph(n,x,y2);
    c1->SetLogy(0);
    B3abs->GetXaxis()->SetLimits(250,600);
    B3abs->GetHistogram()->SetMaximum(1);
    B3abs->GetHistogram()->SetMinimum(-1);
    B3abs->SetMarkerStyle(20);
    B3abs->SetMarkerSize(0.5);
    B3abs->SetMarkerColor(6);
    B3abs->Draw("ap");
    B3emi->SetMarkerStyle(20);
    B3emi->SetMarkerSize(0.5);
    B3emi->SetMarkerColor(4);
    B3emi->Draw("p");
    c1->Print(output);
    
    double y3[nEntries],y4[nEntries];
    for(int i=0;i<nEntries;i++){
        x[i]=1240./photonEnergy[i];
        y1[i]=transmission[i];
        y2[i]=Cherenkov[i];
        y3[i]=lambda2[i];
        y4[i]=Cherenkovdmy[i];
    }
    trans=new TGraph(n,x,y1);
    chere=new TGraph(n,x,y2);
    lamb=new TGraph(n,x,y3);
    cheredmy=new TGraph(n,x,y4);
    c1->SetLogy(0);
    trans->GetXaxis()->SetLimits(200,800);
    trans->GetHistogram()->SetMaximum(1);
    trans->GetHistogram()->SetMinimum(0);
    trans->SetMarkerStyle(20);
    trans->SetMarkerSize(0.5);
    trans->SetMarkerColor(1);
    trans->Draw("ap");
    c1->Print(output);
    chere->GetXaxis()->SetLimits(200,800);
    chere->SetMarkerStyle(20);
    chere->SetMarkerSize(0.5);
    chere->SetMarkerColor(2);
    chere->Draw("ap");
    c1->Print(output);
    lamb->SetMarkerStyle(20);
    lamb->SetMarkerSize(0.5);
    lamb->SetMarkerColor(3);
    lamb->Draw("ap");
    c1->Print(output);
    
    trans->Draw("ap");
    chere->Draw("p");
    lamb->Draw("p");
    c1->Print(output);
    
    chere->GetXaxis()->SetLimits(200,800);
    chere->GetHistogram()->SetMaximum(1);
    chere->GetHistogram()->SetMinimum(-1);
//    trans->Draw("apl");
    chere->SetLineColor(2);
    chere->SetMarkerColor(2);
    chere->Draw("apl");
//    lamb->Draw("pl");
    Y11abs->SetLineColor(3);
    Y11abs->SetMarkerColor(3);
    Y11abs->Draw("pl");
    Y11emi->SetLineColor(3);
    Y11emi->SetMarkerColor(3);
    Y11emi->Draw("pl");
    B3abs->SetLineColor(4);
    B3abs->SetMarkerColor(4);
    B3abs->Draw("pl");
    B3emi->SetLineColor(4);
    B3emi->SetMarkerColor(4);
    B3emi->Draw("pl");
    pmt1->SetLineColor(1);
    pmt1->SetMarkerColor(1);
    pmt1->Draw("pl");
    pmt2->SetLineColor(1);
    pmt2->SetMarkerColor(1);
    pmt2->SetMarkerStyle(24);
    pmt2->Draw("pl");
    c1->Print(output);
    
    
    Y11abs->GetXaxis()->SetLimits(200,800);
    Y11abs->GetHistogram()->SetMaximum(1);
    Y11abs->GetHistogram()->SetMinimum(-1);
    Y11abs->SetLineColor(3);
    Y11abs->SetMarkerColor(3);
    Y11abs->Draw("apl");
    Y11emi->SetLineColor(3);
    Y11emi->SetMarkerColor(3);
    Y11emi->Draw("pl");
    B3abs->SetLineColor(4);
    B3abs->SetMarkerColor(4);
    B3abs->Draw("pl");
    B3emi->SetLineColor(4);
    B3emi->SetMarkerColor(4);
    B3emi->Draw("pl");
    c1->Print(output);
    
    cheredmy->GetXaxis()->SetLimits(200,800);
    cheredmy->GetHistogram()->SetMaximum(1);
    cheredmy->GetHistogram()->SetMinimum(0);
    cheredmy->SetLineColor(2);
    cheredmy->SetMarkerColor(2);
    cheredmy->SetMarkerStyle(20);
    cheredmy->SetMarkerSize(0.5);
    cheredmy->Draw("apl");
    lamb->SetLineColor(3);
    lamb->SetMarkerColor(3);
    lamb->SetMarkerStyle(20);
    lamb->SetMarkerSize(0.5);
    lamb->Draw("pl");
    trans->Draw("pl");
    c1->Print(output);
    
    lamb->GetXaxis()->SetLimits(200,800);
    lamb->GetHistogram()->SetMaximum(1);
    lamb->GetHistogram()->SetMinimum(0);
    lamb->SetMarkerSize(0.3);
    lamb->Draw("apl");
    for(int i=0;i<6;i++){
        chgra[i]->SetLineColor(2);
        chgra[i]->SetMarkerColor(2);
        chgra[i]->SetMarkerStyle(20);
        chgra[i]->SetMarkerSize(0.3);
        chgra[i]->Draw("pl");

        trgra[i]->SetLineColor(1);
        trgra[i]->SetMarkerColor(1);
        trgra[i]->SetMarkerStyle(20);
        trgra[i]->SetMarkerSize(0.3);
        trgra[i]->Draw("pl");
    }
    c1->Print(output);
    

    c1->SetLogy();
    pmt1->GetXaxis()->SetLimits(200,800);
    pmt1->GetHistogram()->SetMaximum(0.5);
    pmt1->GetHistogram()->SetMinimum(1e-2);
    pmt1->SetLineColor(1);
    pmt1->SetMarkerColor(1);
    pmt1->SetMarkerStyle(20);
    pmt1->SetMarkerSize(0.5);
    pmt1->Draw("ap");
    pmt2->SetLineColor(2);
    pmt2->SetMarkerColor(2);
    pmt2->SetMarkerStyle(20);
    pmt2->SetMarkerSize(0.5);
    pmt2->Draw("p");
    c1->Print(output);
    
    sprintf(name,"%s]",output);
    c1->Print(name);
    
    return;
    }
        
    
    
    //********************************
    //
    // mode 1 : 直接PMT読み出しについての光電子数の厚さ依存性
    //
    //********************************

    //
    // 直接PMTでチェレンコフ光を観測した場合
    //
    if(mode == 1 ){
        char output[100]="output1.pdf";
        c1=new TCanvas("c1");
        c1->SetFillStyle(0);
        c1->SetFillColorAlpha(0,0);
        sprintf(name,"%s[",output);
        c1->Print(name);
        
        graphDirectPMT=new TGraphAsymmErrors();
        
    gStyle->SetOptStat(0);
    double en_a,en_b;
    hist=new TH1F("hist","hist",100,200,800);
    hist2=new TH1F("hist2","hist2",100,200,800);
        
    double ent=0;
    double factor=100;
    double refrectionfactor=0.46;
    double airCherenkov=1.36;
    for(int kk=0;kk<6;kk++){
    ent=2*3.14/137*(1.-1./1.05**2)*(1./200-1./800)*1e7*integralvalue[kk];
    cout<<kk+1<<" "<<ent<<" photons"<<endl;
    for(int i=0;i<ent*factor;i++){
        do{
            en_a = gRandom->Uniform(1.38,6.20);
            for(int m=0;photonEnergy[m]<en_a;m++){}
            en_b = gRandom->Uniform(0.00,1.00);
        }while(en_b>chgra[kk]->GetY()[m]);//en_a...energy, en_b...spectrum
        hist->Fill(1240./en_a);
        en_b = gRandom->Uniform(0.00,1.00);
        if(en_b<=R1250_QE[m]){
            hist2->Fill(1240./en_a);
        }
        if(i%1000==0)cout<<"."<<flush;
    }cout<<endl<<flush;
    hist->Draw();
    hist2->SetLineColor(2);
    hist2->SetFillColor(2);
    hist2->SetFillStyle(3004);
    hist2->Draw("same");
    cout<<"Direct PMT observation for Cherenkov photons"<<endl;
    cout<<hist->GetEntries()<<" "
        <<hist2->GetEntries()<<" "
        <<hist2->GetEntries()/hist->GetEntries()<<endl;
        graphDirectPMT->SetPoint(kk,kk+1,hist2->GetEntries()/factor*refrectionfactor+airCherenkov);
        graphDirectPMT->SetPointError(kk,0,0,
                    sqrt(hist2->GetEntries())/factor*refrectionfactor,
                    sqrt(hist2->GetEntries())/factor*refrectionfactor);
    c1->Print(output);
    }
        
        graphDirectPMT->SetMarkerSize(0.5);
        graphDirectPMT->SetMarkerColor(1);
        graphDirectPMT->SetMarkerStyle(24);
        graphDirectPMT->Draw("ap");
        func=new TF1("func","[0]+[1]*x",0,7);
        graphDirectPMT->Fit("func","","",0,7);
        c1->Print(output);
        
        sprintf(name,"%s]",output);
        c1->Print(name);

        return;
    }
    
    
    
    //********************************
    //
    // mode 2 : 直接PMT読み出しについての光電子数の厚さ依存性
    //
    //********************************
    
    //
    // 直接PMTでチェレンコフ光を観測した場合
    // モデル開発
    //  determined to be Eref = 0.466 pm 0.004
    //                   Nairch = 1.42 pm 0.03
    //
    if(mode == 2 ){
        cout<<"Are you OK!; updating output2.pdf anf calc3.root"<<endl;
        cout<<"[1]yes [0]No"<<endl<<">>";
        int a=0;
        int mm,ll;
        cin>>a;
        if(a!=1) return;
        char output[100]="output2.pdf";
        c1=new TCanvas("c1");
        c1->SetFillStyle(0);
        c1->SetFillColorAlpha(0,0);
        sprintf(name,"%s[",output);
        c1->Print(name);
        
        file =new TFile("calc3.root","recreate");
        
        graphDirectPMT=new TGraphAsymmErrors();
        
//        gStyle->SetOptStat(0);
        double en_a,en_b;
        hist=new TH1F("hist","hist",100,200,800);
        hist2=new TH1F("hist2","hist2",100,200,800);
        hists=new TH2F("hists","hists",100,0.4,0.5,100,1.3,1.5);
        
        double alpha=3.20,beta=1.71;
        double ent=0;
        double factor=100;
        double refrectionfactor=0.46;
        double airCherenkov=1.366;
        double chisquare=0;
        double data[6]={4.9, 8.6, 10.8, 14.5, 17.8, 21.1};
        double datasigma[6]={0.2, 0.2, 0.3, 0.3, 0.4, 0.5};

        graphChiSquareEref=new TGraph();
        graphChiSquareAirChere=new TGraph();
        for(int mm=0;mm<20;mm++){
            hist->Reset();
            hist2->Reset();
            refrectionfactor=0.35+mm*0.01;
            cout<<mm<<" "<<ll<<" "<<refrectionfactor<<" "<<airCherenkov<<endl;
        for(int kk=0;kk<6;kk++){
     //ent=2*3.14/137*(1.-1./1.05**2)*(1./200-1./800)*1e7*integralvalue[kk];
            ent=GetNumberOfCherenkovPhotons(1.05,integralvalue[kk]);
            //            cout<<kk+1<<" "<<ent<<" photons"<<endl;
            for(int i=0;i<ent*factor;i++){
                do{
                    en_a = gRandom->Uniform(1.38,6.20);
                    for(int m=0;photonEnergy[m]<en_a;m++){}
                    en_b = gRandom->Uniform(0.00,1.00);
                }while(en_b>chgra[kk]->GetY()[m]);//en_a...energy, en_b...spectrum
                hist->Fill(1240./en_a);
                en_b = gRandom->Uniform(0.00,1.00);
                if(en_b<=R1250_QE[m]){
                    hist2->Fill(1240./en_a);
                }
                if(i%1000==0)cout<<"."<<flush;
            }cout<<endl<<flush;
            hist2->SetLineColor(2);
            hist2->SetFillColor(2);
            hist2->SetFillStyle(3004);
            graphDirectPMT->SetPoint(kk,kk+1,hist2->GetEntries()/factor*refrectionfactor+airCherenkov);
            graphDirectPMT->SetPointError(kk,0,0,
                sqrt(hist2->GetEntries())/factor*refrectionfactor,
                sqrt(hist2->GetEntries())/factor*refrectionfactor);
        }
        
        graphDirectPMT->SetMarkerSize(0.5);
        graphDirectPMT->SetMarkerColor(1);
        graphDirectPMT->SetMarkerStyle(24);
        graphDirectPMT->Draw("ap");
        c1->Print(output);
        chisquare=0;
        for(int ss=0;ss<6;ss++){
            chisquare+=((graphDirectPMT->GetY()[ss]-data[ss])**2/
                        (datasigma[ss])**2);
        }
        cout<<"chi2: "<<chisquare<<endl;
        graphChiSquareEref->SetPoint(mm,refrectionfactor,chisquare);
        hists->Fill(refrectionfactor,airCherenkov,chisquare);
        }
    
        
        refrectionfactor=0.44955;
        for(int ll=0;ll<30;ll++){
            hist->Reset();
            hist2->Reset();
//            refrectionfactor=0.4+mm*0.01;
            airCherenkov=0+ll*0.1;
            cout<<mm<<" "<<ll<<" "<<refrectionfactor<<" "<<airCherenkov<<endl;
            
            for(int kk=0;kk<6;kk++){
                ent=2*3.14/137*(1.-1./1.05**2)*(1./200-1./800)*1e7*integralvalue[kk];
                //            cout<<kk+1<<" "<<ent<<" photons"<<endl;
                for(int i=0;i<ent*factor;i++){
                    do{
                        en_a = gRandom->Uniform(1.38,6.20);
                        for(int m=0;photonEnergy[m]<en_a;m++){}
                        en_b = gRandom->Uniform(0.00,1.00);
                    }while(en_b>chgra[kk]->GetY()[m]);//en_a...energy, en_b...spectrum
                    hist->Fill(1240./en_a);
                    en_b = gRandom->Uniform(0.00,1.00);
                    if(en_b<=R1250_QE[m]){
                        hist2->Fill(1240./en_a);
                    }
                    if(i%1000==0)cout<<"."<<flush;
                }cout<<endl<<flush;
                hist2->SetLineColor(2);
                hist2->SetFillColor(2);
                hist2->SetFillStyle(3004);
                graphDirectPMT->SetPoint(kk,kk+1,hist2->GetEntries()/factor*refrectionfactor+airCherenkov);
                graphDirectPMT->SetPointError(kk,0,0,
                                              sqrt(hist2->GetEntries())/factor*refrectionfactor,
                                              sqrt(hist2->GetEntries())/factor*refrectionfactor);
            }
            
            graphDirectPMT->SetMarkerSize(0.5);
            graphDirectPMT->SetMarkerColor(1);
            graphDirectPMT->SetMarkerStyle(24);
            graphDirectPMT->Draw("ap");
            c1->Print(output);
            chisquare=0;
            for(int ss=0;ss<6;ss++){
                chisquare+=((graphDirectPMT->GetY()[ss]-data[ss])**2/
                            (datasigma[ss])**2);
            }
            cout<<"chi2: "<<chisquare<<endl;
            //graphChiSquareEref->SetPoint(mm,refrectionfactor,chisquare);
         //   hists->Fill(refrectionfactor,airCherenkov,chisquare);
            graphChiSquareAirChere->SetPoint(ll,airCherenkov,chisquare);
        }

        graphChiSquareEref->GetHistogram()->SetMaximum(4e2);
        graphChiSquareEref->GetHistogram()->SetMinimum(0);
        graphChiSquareEref->SetMarkerStyle(24);
        graphChiSquareEref->Draw("ap");
//        c1->Print(output);
        func1=new TF1("func1","[0]*(x-[1])**2+[2]",0.4,0.5);
        func1->SetParameters(1e3,0.45,20);
        graphChiSquareEref->Fit("func1","","",0.4,0.5);
        c1->Print(output);

        graphChiSquareAirChere->GetHistogram()->SetMaximum(3e2);
        graphChiSquareAirChere->GetHistogram()->SetMinimum(0);
        graphChiSquareAirChere->SetMarkerStyle(24);
        graphChiSquareAirChere->Draw("ap");
//        c1->Print(output);
        func2=new TF1("func2","[0]*(x-[1])**2+[2]",0.,5);
        func2->SetParameters(1,1.3,20);
        graphChiSquareAirChere->Fit("func2","","",0.5,3);
        c1->Print(output);

        //hists->Draw("colz");
        graphChiSquareEref->Write("graEref");
        graphChiSquareAirChere->Write("graAirChere");
        file->Write();
        sprintf(name,"%s]",output);
        c1->Print(name);
        
        return;
    }
    

    
    
    //********************************
    //
    // mode 3 : 直接PMT読み出しについての光電子数の厚さ依存性
    //
    //********************************
    
    //
    // モデル
    //      Eref = 0.466 pm 0.004
    //      Nairch = 1.42 pm 0.03
    //
    if(mode == 3 ){
        int a=0;
        int mm,ll;
        char output[100]="output3.pdf";
        c1=new TCanvas("c1");
        c1->SetFillStyle(0);
        c1->SetFillColorAlpha(0,0);
        sprintf(name,"%s[",output);
        c1->Print(name);

        file =new TFile("calc3.root");
        graphDirectPMT=new TGraphAsymmErrors();
        gStyle->SetOptStat(0);
        double en_a,en_b;
        hist=new TH1F("hist","hist",100,200,800);
        hist2=new TH1F("hist2","hist2",100,200,800);
        
        double ent=0;
        double factor=100;
        double refrectionfactor=0.466;
        double airCherenkov=1.42;

        for(int kk=0;kk<6;kk++){
        ent=2*3.14/137*(1.-1./1.05**2)*(1./200-1./800)*1e7*integralvalue[kk];
        cout<<kk+1<<" "<<ent<<" photons"<<endl;
            for(int i=0;i<ent*factor;i++){
            do{
                en_a = gRandom->Uniform(1.38,6.20);
                for(int m=0;photonEnergy[m]<en_a;m++){}
                en_b = gRandom->Uniform(0.00,1.00);
            }while(en_b>chgra[kk]->GetY()[m]);//en_a...energy, en_b...spectrum
            hist->Fill(1240./en_a);
            en_b = gRandom->Uniform(0.00,1.00);
            if(en_b<=R1250_QE[m]){
                hist2->Fill(1240./en_a);
            }
            if(i%1000==0)cout<<"."<<flush;
        }cout<<endl<<flush;
        hist2->SetLineColor(2);
        hist2->SetFillColor(2);
        hist2->SetFillStyle(3004);
        graphDirectPMT->SetPoint(kk,kk+1,hist2->GetEntries()/factor*refrectionfactor+airCherenkov);
        graphDirectPMT->SetPointError(kk,0,0,
                        sqrt(hist2->GetEntries())/factor*refrectionfactor,
                        sqrt(hist2->GetEntries())/factor*refrectionfactor);
            }
        
            //graphDirectPMT->GetXaxis()->SetLabelSize(0);
            //graphDirectPMT->GetYaxis()->SetLabelSize(0);
            graphDirectPMT->GetXaxis()->SetTickLength(0);
            graphDirectPMT->GetYaxis()->SetTickLength(0);
            graphDirectPMT->GetHistogram()->SetMaximum(25);
            graphDirectPMT->GetHistogram()->SetMinimum(3);
            graphDirectPMT->SetMarkerSize(1);
            graphDirectPMT->SetMarkerColor(4);
            graphDirectPMT->SetLineColor(4);
            graphDirectPMT->SetMarkerStyle(24);
            graphDirectPMT->Draw("ap");
            c1->Print(output);
//            chisquare=0;
        
        sprintf(name,"%s]",output);
        c1->Print(name);
        return;
    }

    
    //*******************************:
    //
    // mode 4 : WLSF経由の光電子数モデル
    //
    //*********************************

    if(mode == 4 ){
//        file =new TFile("calc4.root","recreate");
        char output[100]="output4.pdf";
        c1=new TCanvas("c1");
        c1->SetFillStyle(0);
        c1->SetFillColorAlpha(0,0);
        sprintf(name,"%s[",output);
        c1->Print(name);
    
        graphDirectPMT=new TGraphAsymmErrors();
        gStyle->SetOptStat(0);
        hist=new TH1F("hist","hist",100,200,800);
        hist2=new TH1F("hist2","hist2",100,200,800);
        wls=new TH1F("wls","wls",100,200,800);
        wls2=new TH1F("wls2","wls2",100,200,800);//Y, B, B->Y (total)
        wls3=new TH1F("wls3","wls3",100,200,800);//Y
        wls4=new TH1F("wls4","wls4",100,200,800);//B
        wls5=new TH1F("wls5","wls5",100,200,800);//B->Y
        double en_a,en_b;
        double efftrap=0.108;//トラッピング効率
        double ent=0;
        double factor=2000;
        double refrectionfactor=0.466;
        double airCherenkov=0.165;//1.42;
        double effB3=0.357;//再発光効率 B-3
        double effY11=effB3;//再発光効率 Y-11
        
        for(int kk=0;kk<6;kk++){
            ent=2*3.14/137*(1.-1./1.05**2)*(1./200-1./800)*1e7*integralvalue[kk];
            cout<<kk+1<<" "<<ent<<" photons"<<endl;
            for(int i=0;i<ent*factor;i++){
                //Cherenkov photon emit
                do{
                    en_a = gRandom->Uniform(1.38,6.20);
                    for(int m=0;photonEnergy[m]<en_a;m++){}
                    en_b = gRandom->Uniform(0.00,1.00);
                }while(en_b>chgra[kk]->GetY()[m]);//en_a...energy, en_b...spectrum
                hist->Fill(1240./en_a);
                wls->Fill(1240./en_a);

                //(1) B-3がまず表面にあって吸収し、再発光（効率）、ファイバーを伝搬(効率)してPMTに読み出される。
                en_b = gRandom->Uniform(0.00,1.00);
                if(en_b>effB3) continue;//再発光効率
                en_b = gRandom->Uniform(0.00,1.00);
                if(en_b<absWLSF_B3[m]){//B-3 波長変換
                    do{ en_a = gRandom->Uniform(1.38,6.20);
                        for(int m=0;photonEnergy[m]<en_a;m++){}
                        en_b = gRandom->Uniform(0.00,1.00);
                    }while(en_b>emissionWLSF_B3[m]);
                    en_b = gRandom->Uniform(0.00,1.00);
                    if(en_b<=efftrap){//伝搬効率
                        en_b = gRandom->Uniform(0.00,1.00);
                        if(en_b<R9880U_210_QE[m]){
                            wls2->Fill(1240./en_a);
                            wls3->Fill(1240./en_a);
                        }
                    }
                    else{//もしファイバーから漏れたらY-11にいく
                        en_b = gRandom->Uniform(0.00,1.00);
                        if(en_b>0.5) continue;//Y11への入射
                        en_b = gRandom->Uniform(0.00,1.00);
                        if(en_b>effY11) continue;//再発光効率
                        en_b = gRandom->Uniform(0.00,1.00);
                        if(en_b<absWLSF_Y11[m]){//Y11 波長変換
                            do{ en_a = gRandom->Uniform(1.38,6.20);
                                for(int m=0;photonEnergy[m]<en_a;m++){}
                                en_b = gRandom->Uniform(0.00,1.00);
                            }while(en_b>emissionWLSF_Y11[m]);
                            en_b = gRandom->Uniform(0.00,1.00);
                            if(en_b<=efftrap){//伝搬効率
                                en_b = gRandom->Uniform(0.00,1.00);
                                if(en_b<R9880U_210_QE[m]){
                                    wls2->Fill(1240./en_a);
                                    wls5->Fill(1240./en_a);
                                }
                            }
                        }
                    }
                }
                else{//B-3を透過したチェレンコフはY-11へ入射
                    en_b = gRandom->Uniform(0.00,1.00);
                    if(en_b<absWLSF_Y11[m]){//B-3 波長変換
                        do{ en_a = gRandom->Uniform(1.38,6.20);
                            for(int m=0;photonEnergy[m]<en_a;m++){}
                            en_b = gRandom->Uniform(0.00,1.00);
                        }while(en_b>emissionWLSF_Y11[m]);
                        en_b = gRandom->Uniform(0.00,1.00);
                        if(en_b<=efftrap){//伝搬効率
                            en_b = gRandom->Uniform(0.00,1.00);
                            if(en_b<R9880U_210_QE[m]){
                                wls2->Fill(1240./en_a);
                                wls4->Fill(1240./en_a);
                            }
                        }
                    }
                }
                if(i%1000==0)cout<<"."<<flush;
            }
            cout<<endl<<flush;
            hist2->SetLineColor(2);
            hist2->SetFillColor(2);
            hist2->SetFillStyle(3004);
            graphDirectPMT->SetPoint(kk,kk+1,wls2->GetEntries()/factor*refrectionfactor+airCherenkov);
            graphDirectPMT->SetPointError(kk,0,0,
                                          sqrt(wls2->GetEntries())/factor*refrectionfactor,
                                          sqrt(wls2->GetEntries())/factor*refrectionfactor);
        }
    

        graphDirectPMT->GetHistogram()->SetMaximum(1);
        graphDirectPMT->GetHistogram()->SetMinimum(0);
        graphDirectPMT->GetXaxis()->SetLimits(0,6.5);
        graphDirectPMT->SetMarkerSize(1);
        graphDirectPMT->SetMarkerColor(4);
        graphDirectPMT->SetLineColor(4);
        graphDirectPMT->SetMarkerStyle(24);
        graphDirectPMT->Draw("ap");
        c1->Print(output);

        graphDirectPMT->GetXaxis()->SetTickLength(0);
        graphDirectPMT->GetYaxis()->SetTickLength(0);
        graphDirectPMT->Draw("ap");
        c1->Print(output);

//        return;
    
    wls->GetYaxis()->SetRangeUser(0.5,1e4);
    wls->SetLineColor(1);
    wls->SetFillColor(1);
    wls->SetFillStyle(3003);
    wls->Draw();
    wls2->SetLineColor(2);
    wls2->SetFillColor(2);
    wls2->SetFillStyle(3003);
    wls2->Draw("same");
    wls3->SetLineColor(4);//B-3 detection for Cherenkov
    wls3->Draw("same");
    wls4->SetLineColor(3);//Y-11 detection for Cherenkov
    wls4->Draw("same");
    wls5->SetLineColor(6);//Y-11 detection for leaked B-3
    wls5->Draw("same");
    text=new TLatex(300,4e3,"This is #varepsilon_{WLSF} = 0.36");
    text->SetTextSize(0.03);
    text->Draw("same");
    c1->Print(output);

    cout<<" observation via WLS for Cherenkov photons"<<endl;
    cout<<wls->GetEntries()<<" \n"
    <<wls2->GetEntries()<<" \n"
    <<wls3->GetEntries()<<" \n"
    <<wls4->GetEntries()<<" \n"
    <<wls4->GetEntries()<<" \n"
    <<wls2->GetEntries()/wls->GetEntries()<<endl;
    
        
//    cout<<"Comparison with exp. data"<<endl;
//    cout<<wls2->GetEntries()/hist2->GetEntries()<<endl;
    sprintf(name,"%s]",output);
    c1->Print(name);
        return;
    }


    
    //*******************************:
    //
    // mode 5 : WLSF経由の光電子数モデル
    // fitting parameter Ecore, N0
    //
    //*********************************
    
    if(mode == 5 ){
        file =new TFile("calc5.root","recreate");
        char output[100]="output5.pdf";
        c1=new TCanvas("c1");
        c1->SetFillStyle(0);
        // c1->SetFillColorAlpha(0,0);
        sprintf(name,"%s[",output);
        c1->Print(name);
        
        graphDirectPMT=new TGraphAsymmErrors();
        gStyle->SetOptStat(0);
        hist=new TH1F("hist","hist",100,200,800);
        hist2=new TH1F("hist2","hist2",100,200,800);
        wls=new TH1F("wls","wls",100,200,800);
        wls2=new TH1F("wls2","wls2",100,200,800);//Y, B, B->Y (total)
        wls3=new TH1F("wls3","wls3",100,200,800);//Y
        wls4=new TH1F("wls4","wls4",100,200,800);//B
        wls5=new TH1F("wls5","wls5",100,200,800);//B->Y
        int mm,ll;
        double en_a,en_b;
        double efftrap=0.108;//トラッピング効率
        double ent=0;
        double factor=200;
        double refrectionfactor=0.466;
        double chisquare=0;

        double data[6]={0.29,0.55,0.72,0.70,0.74,0.82};
        double datasigma[6]={0.03,0.05,0.07,0.07,0.07,0.09};
        
        //free parameters
        double airCherenkov=0.08;//1.42;
        double effB3=0.356;//再発光効率 B-3
        double effY11=effB3;//再発光効率 Y-11
        
        graphChiSquareAirChere=new TGraph();
        graphChiSquareWLSFcore=new TGraph();
        
        for(int mm=0;mm<15;mm++){
            hist->Reset();
            hist2->Reset();
            wls->Reset();
            wls2->Reset();
            wls3->Reset();
            wls4->Reset();
            wls5->Reset();

            airCherenkov = 0.0+mm*0.02;
            cout<<mm<<" "<<airCherenkov<<endl;
        for(int kk=0;kk<6;kk++){
            ent=2*3.14/137*(1.-1./1.05**2)*(1./200-1./800)*1e7*integralvalue[kk];
          //  cout<<kk+1<<" "<<ent<<" photons"<<endl;
            for(int i=0;i<ent*factor;i++){
                //Cherenkov photon emit
                do{
                    en_a = gRandom->Uniform(1.38,6.20);
                    for(int m=0;photonEnergy[m]<en_a;m++){}
                    en_b = gRandom->Uniform(0.00,1.00);
                }while(en_b>chgra[kk]->GetY()[m]);//en_a...energy, en_b...spectrum
                hist->Fill(1240./en_a);
                
                //(1) B-3がまず表面にあって吸収し、再発光（効率）、ファイバーを伝搬(効率)してPMTに読み出される。
                en_b = gRandom->Uniform(0.00,1.00);
                if(en_b>effB3) continue;//再発光効率
                en_b = gRandom->Uniform(0.00,1.00);
                if(en_b<absWLSF_B3[m]){//B-3 波長変換
                    do{ en_a = gRandom->Uniform(1.38,6.20);
                        for(int m=0;photonEnergy[m]<en_a;m++){}
                        en_b = gRandom->Uniform(0.00,1.00);
                    }while(en_b>emissionWLSF_B3[m]);
                    en_b = gRandom->Uniform(0.00,1.00);
                    if(en_b<=efftrap){//伝搬効率
                        en_b = gRandom->Uniform(0.00,1.00);
                        if(en_b<R9880U_210_QE[m]){
                            wls2->Fill(1240./en_a);
                            wls3->Fill(1240./en_a);
                        }
                    }
                    else{//もしファイバーから漏れたらY-11にいく
                        en_b = gRandom->Uniform(0.00,1.00);
                        if(en_b>0.5) continue;//Y11への入射
                        en_b = gRandom->Uniform(0.00,1.00);
                        if(en_b>effY11) continue;//再発光効率
                        en_b = gRandom->Uniform(0.00,1.00);
                        if(en_b<absWLSF_Y11[m]){//Y11 波長変換
                            do{ en_a = gRandom->Uniform(1.38,6.20);
                                for(int m=0;photonEnergy[m]<en_a;m++){}
                                en_b = gRandom->Uniform(0.00,1.00);
                            }while(en_b>emissionWLSF_Y11[m]);
                            en_b = gRandom->Uniform(0.00,1.00);
                            if(en_b<=efftrap){//伝搬効率
                                en_b = gRandom->Uniform(0.00,1.00);
                                if(en_b<R9880U_210_QE[m]){
                                    wls2->Fill(1240./en_a);
                                    wls5->Fill(1240./en_a);}}}}}
                else{//B-3を透過したチェレンコフはY-11へ入射
                    en_b = gRandom->Uniform(0.00,1.00);
                    if(en_b<absWLSF_Y11[m]){//B-3 波長変換
                        do{ en_a = gRandom->Uniform(1.38,6.20);
                            for(int m=0;photonEnergy[m]<en_a;m++){}
                            en_b = gRandom->Uniform(0.00,1.00);
                        }while(en_b>emissionWLSF_Y11[m]);
                        en_b = gRandom->Uniform(0.00,1.00);
                        if(en_b<=efftrap){//伝搬効率
                            en_b = gRandom->Uniform(0.00,1.00);
                            if(en_b<R9880U_210_QE[m]){
                                wls2->Fill(1240./en_a);
                                wls4->Fill(1240./en_a);}}}}
                if(i%1000==0)cout<<"."<<flush;}
            cout<<endl<<flush;
            graphDirectPMT->SetPoint(kk,kk+1,wls2->GetEntries()/factor*refrectionfactor+airCherenkov);
            graphDirectPMT->SetPointError(kk,0,0,
                                          sqrt(wls2->GetEntries())/factor*refrectionfactor,
                                          sqrt(wls2->GetEntries())/factor*refrectionfactor);
//            cout<<wls2->GetEntries()/factor*refrectionfactor+airCherenkov<<endl;
        }
        graphDirectPMT->SetMarkerSize(1);
        graphDirectPMT->SetMarkerColor(4);
        graphDirectPMT->SetLineColor(4);
        graphDirectPMT->SetMarkerStyle(24);
        graphDirectPMT->Draw("ap");
        c1->Print(output);
         
            chisquare=0;
            for(int ss=0;ss<6;ss++){
                chisquare+= ((data[ss] - graphDirectPMT->GetY()[ss])/datasigma[ss])**2;
            }
            graphChiSquareAirChere->SetPoint(mm,airCherenkov,chisquare);
            cout<<chisquare<<endl;
        }
    
        graphChiSquareAirChere->SetMarkerStyle(24);
        graphChiSquareAirChere->SetMarkerSize(1);
        graphChiSquareAirChere->GetHistogram()->SetMaximum(80);
        graphChiSquareAirChere->GetHistogram()->SetMinimum(0);
        graphChiSquareAirChere->Draw("ap");
        func1=new TF1("func1","[0]*(x-[1])**2+[2]",0,2);
        func1->SetParameters(100,0.16,7);
        graphChiSquareAirChere->Fit("func1","","",0.,0.3);
        c1->Print(output);

        //return;
        
        airCherenkov=0.161648;
        factor=1000;
        for(int mm=0;mm<10;mm++){
            hist->Reset();
            hist2->Reset();
            wls->Reset();
            wls2->Reset();
            wls3->Reset();
            wls4->Reset();
            wls5->Reset();
            
            effB3=0.20+mm*0.03;
            effY11=effB3;
            cout<<mm<<" "<<effB3<<endl;
            for(int kk=0;kk<6;kk++){
                ent=2*3.14/137*(1.-1./1.05**2)*(1./200-1./800)*1e7*integralvalue[kk];
                //  cout<<kk+1<<" "<<ent<<" photons"<<endl;
                for(int i=0;i<ent*factor;i++){
                    //Cherenkov photon emit
                    do{
                        en_a = gRandom->Uniform(1.38,6.20);
                        for(int m=0;photonEnergy[m]<en_a;m++){}
                        en_b = gRandom->Uniform(0.00,1.00);
                    }while(en_b>chgra[kk]->GetY()[m]);//en_a...energy, en_b...spectrum
                    hist->Fill(1240./en_a);
                    
                    //(1) B-3がまず表面にあって吸収し、再発光（効率）、ファイバーを伝搬(効率)してPMTに読み出される。
                    en_b = gRandom->Uniform(0.00,1.00);
                    if(en_b>effB3) continue;//再発光効率
                    en_b = gRandom->Uniform(0.00,1.00);
                    if(en_b<absWLSF_B3[m]){//B-3 波長変換
                        do{ en_a = gRandom->Uniform(1.38,6.20);
                            for(int m=0;photonEnergy[m]<en_a;m++){}
                            en_b = gRandom->Uniform(0.00,1.00);
                        }while(en_b>emissionWLSF_B3[m]);
                        en_b = gRandom->Uniform(0.00,1.00);
                        if(en_b<=efftrap){//伝搬効率
                            en_b = gRandom->Uniform(0.00,1.00);
                            if(en_b<R9880U_210_QE[m]){
                                wls2->Fill(1240./en_a);
                                wls3->Fill(1240./en_a);
                            }
                        }
                        else{//もしファイバーから漏れたらY-11にいく
                            en_b = gRandom->Uniform(0.00,1.00);
                            if(en_b>0.5) continue;//Y11への入射
                            en_b = gRandom->Uniform(0.00,1.00);
                            if(en_b>effY11) continue;//再発光効率
                            en_b = gRandom->Uniform(0.00,1.00);
                            if(en_b<absWLSF_Y11[m]){//Y11 波長変換
                                do{ en_a = gRandom->Uniform(1.38,6.20);
                                    for(int m=0;photonEnergy[m]<en_a;m++){}
                                    en_b = gRandom->Uniform(0.00,1.00);
                                }while(en_b>emissionWLSF_Y11[m]);
                                en_b = gRandom->Uniform(0.00,1.00);
                                if(en_b<=efftrap){//伝搬効率
                                    en_b = gRandom->Uniform(0.00,1.00);
                                    if(en_b<R9880U_210_QE[m]){
                                        wls2->Fill(1240./en_a);
                                        wls5->Fill(1240./en_a);}}}}}
                    else{//B-3を透過したチェレンコフはY-11へ入射
                        en_b = gRandom->Uniform(0.00,1.00);
                        if(en_b<absWLSF_Y11[m]){//B-3 波長変換
                            do{ en_a = gRandom->Uniform(1.38,6.20);
                                for(int m=0;photonEnergy[m]<en_a;m++){}
                                en_b = gRandom->Uniform(0.00,1.00);
                            }while(en_b>emissionWLSF_Y11[m]);
                            en_b = gRandom->Uniform(0.00,1.00);
                            if(en_b<=efftrap){//伝搬効率
                                en_b = gRandom->Uniform(0.00,1.00);
                                if(en_b<R9880U_210_QE[m]){
                                    wls2->Fill(1240./en_a);
                                    wls4->Fill(1240./en_a);}}}}
                    if(i%1000==0)cout<<"."<<flush;}
                cout<<endl<<flush;
                graphDirectPMT->SetPoint(kk,kk+1,wls2->GetEntries()/factor*refrectionfactor+airCherenkov);
                graphDirectPMT->SetPointError(kk,0,0,
                                              sqrt(wls2->GetEntries())/factor*refrectionfactor,
                                              sqrt(wls2->GetEntries())/factor*refrectionfactor);
                //            cout<<wls2->GetEntries()/factor*refrectionfactor+airCherenkov<<endl;
            }
            graphDirectPMT->SetMarkerSize(1);
            graphDirectPMT->SetMarkerColor(4);
            graphDirectPMT->SetLineColor(4);
            graphDirectPMT->SetMarkerStyle(24);
            graphDirectPMT->Draw("ap");
            c1->Print(output);
            
            chisquare=0;
            for(int ss=0;ss<6;ss++){
                chisquare+= ((data[ss] - graphDirectPMT->GetY()[ss])/datasigma[ss])**2;
            }
            graphChiSquareWLSFcore->SetPoint(mm,effB3,chisquare);
            cout<<chisquare<<endl;
        }
        
        
        graphChiSquareWLSFcore->SetMarkerStyle(24);
        graphChiSquareWLSFcore->SetMarkerSize(1);
        graphChiSquareWLSFcore->GetHistogram()->SetMaximum(80);
        graphChiSquareWLSFcore->GetHistogram()->SetMinimum(0);
        graphChiSquareWLSFcore->Draw("ap");
        func2=new TF1("func2","[0]*(x-[1])**2+[2]",0,0.6);
        func2->SetParameters(100,0.35,6);
        graphChiSquareWLSFcore->Fit("func2","","",0.3,0.45);
        c1->Print(output);

        sprintf(name,"%s]",output);
        c1->Print(name);
        return;
    }
    
    
    //*******************************:
    //
    // mode 6 : WLSF経由の光電子数モデル
    //
    //*********************************
    
    if(mode == 6 ){
        file=new TFile("calc6.root","recreate");
        char output[100]="output6.pdf";
        c1=new TCanvas("c1");
        c1->SetFillStyle(0);
        c1->SetFillColorAlpha(0,0);
        sprintf(name,"%s[",output);
        c1->Print(name);
        c1->SetLogy();
        
        graphDirectPMT=new TGraphAsymmErrors();
        gStyle->SetOptStat(0);
        hist=new TH1F("hist","hist",100,200,800);
        hist2=new TH1F("hist2","hist2",100,200,800);
        wls=new TH1F("wls","wls",100,200,800);
        wls2=new TH1F("wls2","wls2",100,200,800);//Y, B, B->Y (total) Np.e.
        wls3=new TH1F("wls3","wls3",100,200,800);//Y
        wls4=new TH1F("wls4","wls4",100,200,800);//B
        wls5=new TH1F("wls5","wls5",100,200,800);//B->Y
        wls6=new TH1F("wls6","wls6",100,200,800);//Y, B, B->Y (total) Nph
        int mm,ll,kk;
        double en_a,en_b;
        double efftrap=0.108;//トラッピング効率
        double ent=0;
        double factor=10000;
        double refrectionfactor=0.466;
        double airCherenkov=0.165;//1.42; for via WLSF
        double airCherenkov2=1.42;// for Direct PMT
        double effB3=0.357;//再発光効率 B-3
        double effY11=effB3;//再発光効率 Y-11

//        int kk=0;
        for(int kk=0;kk<6;kk++){
            ent=2*3.14/137*(1.-1./1.05**2)*(1./200-1./800)*1e7*integralvalue[kk];
            cout<<kk+1<<" "<<ent<<" photons"<<endl;
            for(int i=0;i<ent*factor;i++){
                //Cherenkov photon emit
                do{
                    en_a = gRandom->Uniform(1.38,6.20);
                    for(int m=0;photonEnergy[m]<en_a;m++){}
                    en_b = gRandom->Uniform(0.00,1.00);
                }while(en_b>chgra[kk]->GetY()[m]);//en_a...energy, en_b...spectrum
                hist->Fill(1240./en_a,refrectionfactor/factor);
                wls->Fill(1240./en_a,refrectionfactor/factor);

                //For Direct PMT
                en_b = gRandom->Uniform(0.00,1.00);
                if(en_b<=R1250_QE[m]){
                    hist2->Fill(1240./en_a,refrectionfactor/factor);
                }

                //(1) B-3がまず表面にあって吸収し、再発光（効率）、ファイバーを伝搬(効率)してPMTに読み出される。
                en_b = gRandom->Uniform(0.00,1.00);
                if(en_b>effB3) continue;//再発光効率
                en_b = gRandom->Uniform(0.00,1.00);
                if(en_b<absWLSF_B3[m]){//B-3 波長変換
                    do{ en_a = gRandom->Uniform(1.38,6.20);
                        for(int m=0;photonEnergy[m]<en_a;m++){}
                        en_b = gRandom->Uniform(0.00,1.00);
                    }while(en_b>emissionWLSF_B3[m]);
                    en_b = gRandom->Uniform(0.00,1.00);
                    if(en_b<=efftrap){//伝搬効率
                        wls6->Fill(1240./en_a,refrectionfactor/factor);
                        en_b = gRandom->Uniform(0.00,1.00);
                        if(en_b<R9880U_210_QE[m]){
                            wls2->Fill(1240./en_a,refrectionfactor/factor);
                            wls3->Fill(1240./en_a,refrectionfactor/factor);
                        }
                    }
                    else{//もしファイバーから漏れたらY-11にいく
                        en_b = gRandom->Uniform(0.00,1.00);
                        if(en_b>0.5) continue;//Y11への入射
                        en_b = gRandom->Uniform(0.00,1.00);
                        if(en_b>effY11) continue;//再発光効率
                        en_b = gRandom->Uniform(0.00,1.00);
                        if(en_b<absWLSF_Y11[m]){//Y11 波長変換
                            do{ en_a = gRandom->Uniform(1.38,6.20);
                                for(int m=0;photonEnergy[m]<en_a;m++){}
                                en_b = gRandom->Uniform(0.00,1.00);
                            }while(en_b>emissionWLSF_Y11[m]);
                            en_b = gRandom->Uniform(0.00,1.00);
                            if(en_b<=efftrap){//伝搬効率
                                wls6->Fill(1240./en_a,refrectionfactor/factor);
                                en_b = gRandom->Uniform(0.00,1.00);
                                if(en_b<R9880U_210_QE[m]){
                                    wls2->Fill(1240./en_a,refrectionfactor/factor);
                                    wls5->Fill(1240./en_a,refrectionfactor/factor);
                                }
                            }
                        }
                    }
                }
                else{//B-3を透過したチェレンコフはY-11へ入射
                    en_b = gRandom->Uniform(0.00,1.00);
                    if(en_b<absWLSF_Y11[m]){//B-3 波長変換
                        do{ en_a = gRandom->Uniform(1.38,6.20);
                            for(int m=0;photonEnergy[m]<en_a;m++){}
                            en_b = gRandom->Uniform(0.00,1.00);
                        }while(en_b>emissionWLSF_Y11[m]);
                        en_b = gRandom->Uniform(0.00,1.00);
                        if(en_b<=efftrap){//伝搬効率
                            wls6->Fill(1240./en_a,refrectionfactor/factor);
                            en_b = gRandom->Uniform(0.00,1.00);
                            if(en_b<R9880U_210_QE[m]){
                                wls2->Fill(1240./en_a,refrectionfactor/factor);
                                wls4->Fill(1240./en_a,refrectionfactor/factor);
                            }
                        }
                    }
                }
                if(i%1000==0)cout<<"."<<flush;
            }
            cout<<endl<<flush;
//        }
        
        wls->GetYaxis()->SetRangeUser(1e-4,10);
        wls->SetLineColor(1);
        wls->SetFillColor(1);
        wls->SetFillStyle(3003);
        wls->Draw();
        hist2->SetLineColor(5);
        hist2->Draw("same");
        
        wls2->SetLineColor(2);
        wls2->SetFillColor(2);
        wls2->SetFillStyle(3003);
        wls2->Draw("same");
        wls3->SetLineColor(4);//B-3 detection for Cherenkov
        wls3->Draw("same");
        wls4->SetLineColor(3);//Y-11 detection for Cherenkov
        wls4->Draw("same");
        wls5->SetLineColor(6);//Y-11 detection for leaked B-3
        wls5->Draw("same");
        wls6->SetLineColor(7);//Nph
        wls6->Draw("same");
        text=new TLatex(300,4e3,"This is #varepsilon_{WLSF} = 0.36");
        text->SetTextSize(0.03);
        text->Draw("same");
        c1->Print(output);
        
        cout<<"["<<kk<<"] Observation via WLS for Cherenkov photons"<<endl;
        cout<<wls->Integral()<<" origin Cherenkov photon\n"
        <<hist2->Integral()<<": Direct PMT Np.e.\n"
        <<wls2->Integral()<<": B-3 + Y-11 + B->Y Np.e.\n"
        <<wls3->Integral()<<": B-3 Np.e.\n"
        <<wls4->Integral()<<": Y-11 Np.e.\n"
        <<wls5->Integral()<<": B->Y Np.e.\n"
        <<wls6->Integral()<<": B-3 + Y-11 + B->Y Nph\n"
        <<wls6->Integral()/wls->Integral()<<": coll. eff."<<endl;

        graphDirectPMT->SetPoint(kk,kk+1,wls6->Integral()/wls->Integral());
        graphDirectPMT->SetPointError(kk,0,0,
                    sqrt(wls6->Integral()*factor)/wls->Integral()/factor,
                    sqrt(wls6->Integral()*factor)/wls->Integral()/factor);
            
    }
 
        c1->SetLogy(0);
        graphDirectPMT->SetMarkerSize(1);
        graphDirectPMT->SetMarkerStyle(24);
        graphDirectPMT->Draw("ap");
        c1->Print(output);
        func3=new TF1("func3","[0]*(1-exp(-x/[1]))+[2]",0,7);
        func3->SetParameters(1e-2,1,1e-3);
        graphDirectPMT->Fit("func3","","",0,7);
        c1->Print(output);

        
        file->Write();
        graphDirectPMT->Write("colleff");
        //    cout<<"Comparison with exp. data"<<endl;
        //    cout<<wls2->GetEntries()/hist2->GetEntries()<<endl;
        sprintf(name,"%s]",output);
        c1->Print(name);
        return;
    }


    
      

  return;
}
