#include "lib/QE_R9880U_210.hh"
#include "lib/QE_R1250_03.hh"
#include "lib/Aerogel.hh"
#include "lib/Cherenkov.hh"
#include "lib/Kuraray_B3_300.hh"
#include "lib/Kuraray_Y11_300.hh"
#include "lib/PhotonEnergy.hh"


void initialize(){
    file=new TFile("rootfile/opt.root","recreate");
    char name[100];
    const int nEntries = 80;
    
    TGraph*chgra[6];
    for(int i=0;i<6;i++) chgra[i]=new TGraph();
    TGraph*trgra[6];
    for(int i=0;i<6;i++) trgra[i]=new TGraph();
    ratio=new TH1F("ratio","ratio",10,0,9);

    for(int i=0;i<nEntries;i++){
        for(int j=0;j<6;j++){
            trgra[j]->SetPoint(i,
                    1240./photonEnergy[i],
                    AerogelTransmitttance((j+0.5)*1.05,photonEnergy[i]));
            chgra[j]->SetPoint(i,
                1240./photonEnergy[i],
                Cherenkov(photonEnergy[i])*
                AerogelTransmitttance((j+0.5)*1.05,photonEnergy[i]));
        }
    }
    
    double integralvalue[7]={0};
    for(int m=0;m<nEntries;m++)
        integralvalue[6]+=Cherenkov(photonEnergy[m]);
    cout<<"[origin]"<<integralvalue[6]<<endl;
    for(int i=0;i<6;i++){
        for(int m=0;m<nEntries;m++) integralvalue[i]+=chgra[i]->GetY()[m];
        cout<<"["<<i<<"] "<<integralvalue[i]<<endl;
    }
    for(int i=0;i<6;i++)
        integralvalue[i]=integralvalue[i]/integralvalue[6];

    for(int i=0;i<6;i++){
        sprintf(name,"chgra%d",i);
        chgra[i]->Write(name);
        sprintf(name,"trgra%d",i);
        trgra[i]->Write(name);
    }
    for(int i=0;i<7;i++){
        ratio->SetBinContent(i,integralvalue[i]);
    }
    ratio->Write("ratio");
    
    file->Close();
}

